import 'package:flutter/material.dart';
import 'package:libcli/log/log.dart' as log;
import 'package:libcli/log/color.dart';
import 'package:libui/async/async_provider.dart';

class AwaitProvider with ChangeNotifier {
  List<AsyncProvider> list;

  AsyncStatus status() {
    for (var p in list) {
      if (p.asyncStatus == AsyncStatus.wait) {
        return AsyncStatus.wait;
      } else if (p.asyncStatus == AsyncStatus.error) {
        return AsyncStatus.error;
      }
    }
    return AsyncStatus.ready;
  }

  void reload() {
    list.forEach((provider) {
      if (provider.asyncStatus == AsyncStatus.error) {
        provider.asyncStatus == AsyncStatus.wait;
      }

      if (provider.asyncStatus == AsyncStatus.wait) {
        Future.microtask(() {
          provider.load().then((_) {
            log.debug(here, 'load ${provider.runtimeType}');
            provider.asyncStatus = AsyncStatus.ready;
            provider.notifyListeners();
          }).catchError((e, s) {
            log.error(here, e, s);
            provider.asyncStatus = AsyncStatus.error;
          });
        });
      }
    });
  }
}
