import 'package:flutter/material.dart';
import 'package:provider/provider.dart';
import 'package:libui/i18n/i18n_provider.dart';

//This will allow you to add `.i18n` to your strings
extension Localization on String {
  String i18n(BuildContext context) {
    var provider = Provider.of<I18nProvider>(context);
    assert(provider != null, 'I18nProvider need inject in context');
    return provider.translate(this);
  }
}
