import 'dart:async';
import 'dart:convert';
import 'package:libui/assets/assets.dart' as assets;
import 'package:libui/i18n/i18n_state.dart';
import 'package:libcli/log/log.dart' as log;
import 'package:libcli/log/color.dart';

class I18nModel {
  String _key;

  I18nState _state;

  I18nState get state => _state;

  Future<void> read(String pageName, String localeID) async {
    assert(pageName.length > 0);
    assert(localeID.length > 0);

    var key = '${pageName}_$localeID';
    if (_key != key) {
      String jsonContent = await assets.get('i18n/${key}.json');
      log.debug('i18n', 'load $GREEN$pageName ${RESET}with $localeID');

      var localization = json.decode(jsonContent);
      _state = I18nState(localization);
      _key = key;
    }
  }
}
